unit MFK3Test;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testutils, testregistry, mfk3sys, fgl, dateutils,
  mfkmock;

type

  { TMFK3Test }

  TMFK3Test= class(TTestCase)
  protected
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TesteEinmalbuchung;
  end;

  (* Generische Mocklisten *)
  TEinmalListe = specialize TFPGObjectList<TBuchungEinmalig>;

implementation

var
  Einmalliste : TEinmalListe;
  Buchung : TBuchungEinmalig;




procedure TMFK3Test.SetUp;
var
  i: Integer;

begin
  Einmalliste := TEinmalListe.Create(True);
  Einmalliste.Assign(MockListeBuchungEinmalig);

end;

procedure TMFK3Test.TearDown;
begin
  //Einmalliste.Free;        //-> Wenn ich den entkommentiere, dann knallts!
  //Einmalliste := nil;
end;

procedure TMFK3Test.TesteEinmalbuchung;
var
  Buchung : TBuchungEinmalig;

  procedure LeerenNamenZuweisen(Buchung : TBuchungEinmalig);
  begin
    Buchung.Name := '';
  end;

begin
  (*
  Testfälle:
  Name darf nicht leer sein
  Kategorie darf nicht leer sein
  Betrag darf nicht negativ sein
  Datumsvergleich positiv bei gleichem Monat und Jahr
  *)

  (* Prüfung des Namens *)
  Buchung := TBuchungEinmalig.Create;
  with Buchung do begin
    Name := 'bla'
  end;

  try
    Buchung.Name := '';
    AssertTrue('Zuweisung leerer Name an Buchung wurde nicht abgefangen!', False);
  except
    on EBuchungException do AssertTrue(
    'Zuweisung leerer Name an Buchung wurde korrekt abgefangen', True);
  end;


end;



initialization

  RegisterTest(TMFK3Test);
end.

